/*
 * FT8_HW.h
 *
 *  Created on: Oct 9, 2018
 *      Author: Mazarei
 */

#ifndef FT8_HW_H_
#define FT8_HW_H_
#include <stm32f10x.h>
#include <stdint-gcc.h>

#define SPIx_RCC      RCC_APB2Periph_SPI1
#define SPIx          SPI1
#define SPI_GPIO_RCC  RCC_APB2Periph_GPIOA
#define SPI_GPIO      GPIOA
#define SPI_PIN_MOSI  GPIO_Pin_7
#define SPI_PIN_MISO  GPIO_Pin_6
#define SPI_PIN_SCK   GPIO_Pin_5



#define FT8_CS_Pin			GPIO_Pin_4
#define FT8_CS_GPIO			GPIOA

#define FT8_PD_Pin			GPIO_Pin_3
#define FT8_PD_GPIO			GPIOA

#define FT8_pdn_set()		FT8_PD_GPIO->BRR = FT8_PD_Pin
#define FT8_pdn_clear()		FT8_PD_GPIO->BSRR = FT8_PD_Pin
#define FT8_cs_set()		FT8_CS_GPIO->BRR = FT8_CS_Pin
#define FT8_cs_clear()		FT8_CS_GPIO->BSRR = FT8_CS_Pin

#define fetch_flash_byte(x)	(*x)
#define spi_receive(data)	SPIx_Transfer(data)
#define spi_transmit(data)	SPIx_Transfer(data)

#define DELAY_MS(ms) delay(ms)


void SPIx_Init();
uint8_t SPIx_Transfer(uint8_t data);
void delay(unsigned int nCount);

#endif /* FT8_HW_H_ */
